"""
 * ImageProcessingBasics is a demonstration of using the PImage class to process photo images.
 * In this program, we are using Processing in "static" mode, without the setup() and draw()
 * methods.
"""

img = loadImage("perG-1800.jpg");     # load an image from the drive into a reference
                                         # This image needs to be located in the same
                                         # directory as this program.
size(1200, 800 );                        # Establish size of window (same size as image)
image(img, 0, 0);                        # displays an image at upperleft 0,0

for row in range(height):
    for col in range(width):
        # Here's the classic way to get a pixel's color
        c = img.get(col,row)         # Gets the color of the given pixel  
        r = red(c)                   # Pulls out the red value (0-255)
        g = green(c)                 # Pulls out the green value (0-255)
        b = blue(c)                  # Pulls out the blue value (0-255)
        
        # The next line can be used to display the colors for debugging, if needed
        print("The pixel at " + str(row) + "," + str(col) + " has colors: " + str(r) + \
              ", " + str(g) + ", " + str(b))
        
        '''
        If you want to change the color of the pixel, you use the .set() method.
        Take the red, green, and blue values and alter them according to 
        whatever function you are trying to implement, and then "set" the 
        specified pixel to the new color.
        '''
        newR = r
        newG = g
        newB = 0                    # Note that we're setting blue value to 0.
                                    # Can you predict what this image is going to look like?
        img.set(col,row,color(newR, newG, newB));
    
# Now that the .set() method has altered pixels in the image, we need to display this 
# new version of the image on the screen.

# displays the edited image at upperleft 0,0 (used with first strategy)
# image(img, 0, 0)             

# save the image for later reference
img.save("altered.png")
